//Ce programme permet d'afficher l'intensité lumineuse détectée par une photorésistance.

//Niveau 1 : Brancher la photorésistance sur l'entrée analogique A0, téléverser le programme puis ouvrir le moniteur série (bouton en haut à droite de la fenêtre)
//Niveau 2 : Si ça marche, modifier le programme de sorte à diminuer le temps entre deux mesures à 100ms au lieu de 1000ms... Téléverser puis dans l'onglet "Outils", cliquer sur "Traceur série" afin d'afficher la courbe de mesure.
//Niveau 3 : La grandeur mesurée par la photorésistance est stockée sur 10 bits ce qui explique qu'elle prenne des valeurs entre 0 et 1023 (2^10 possibilités). 
//           En réalité, ces valeurs correspondent à 1024 valeurs de tension aux bornes de la résistance comprises entre 0 et 5V.
//           Compléter les lignes du programme de sorte à afficher dans le moniteur série la tension aux bornes de la photorésistance... Enregistrer et tester !


const int photoresistance = A0;
float valeur = 0;                   // Cette variable utilisée dans loop peut être déclarée ici ou dans loop !

void setup() {
  pinMode(photoresistance, INPUT);          //La "fonction" pinMode() définit ici la broche A0 comme une entrée (INPUT)
  Serial.begin(9600);                       //La "fonction" Serial.begin() initialise la communication entre la carte et l'ordinateur, ici avec une vitesse de transmission de 9600 bits/s
}

void loop() {
  valeur = analogRead(photoresistance);     //La "fonction" analogRead() lit la valeur détectée par le capteur branché en A0, on stocke cette valeur dans une "variable" nommée "valeur" et de type "float" 
  Serial.print("Valeur mesurée : ");        //La "fonction" Serial.print() écrit du texte dans la fenêtre de communication avec la carte, le texte à écrire doit être mis entre guillemets
  Serial.println(valeur);                   //La "fonction" Serial.println() fait la même chose que Serial.print() mais elle passe en plus à la ligne après écriture
  
   //ligne à modifier dans le niveau 3
   //ligne à compléter dans le niveau 3
   //ligne à compléter dans le niveau 3
  delay(1000);
}
