//Ce programme allume une lampe lorsque la luminosité détectée par la photorésistance passe sous une valeur seuil. (principe d'allumage des lampadaires urbains, ou d'une alarme silencieuse). La lampe pourrait être remplacée par un buzzer de sorte à réaliser une vraie alarme !

//Niveau 1 : Brancher la photorésistance et la LED sur les entrées adéquates, téléverser le programme et tester la réaction de la LED.
//Niveau 2 : Modifier la valeur seuil... Enregistrer et tester !
//Niveau 3 : Modifier le programme de sorte à ajouter une condition supplémentaire : si la luminosité est encore plus faible, deux LEDs s'allument ! Enregistrer, téléverser et tester !

const int photoresistance = A0;
const int LEDrouge = 2;
int valeur = 0 ;                                   // peut être déclarée dans loop

void setup() {
  pinMode(photoresistance, INPUT);
  pinMode(LEDrouge, OUTPUT);
  Serial.begin(9600);
}

void loop() {
  valeur = analogRead(photoresistance);
  
  if(valeur > 300){                                //La "condition" "if" (si) fait faire quelque chose au microcontrôleur si une certaine condition est remplie, ici la condition à remplir est "valeur>300" (c'est-à-dire la valeur détectée par la photorésistance doit être supérieure à 300)
    digitalWrite(LEDrouge, LOW);                   //L'action à réaliser doit être mise entre accolades, ici la LED doit s'éteindre
  }
  else if(valeur <= 300){                           //On peut ajouter une autre condition "else if" (sinon si)
    digitalWrite(LEDrouge, HIGH);                  //Si la valeur détectée est inférieure ou égale à 300, la LED s'allume
  }

}
