// Ce programme permet de mesurer la distance à un obstacle grâce à un émetteur-récepteur d'ultrasons. Dans le "niveau 3" on se propose de compléter le programme afin que la carte fasse office de radar de recul

//Niveau 1 : Réaliser les branchements de l'émetteur-récepteur d'ultrasons, téléverser le programme, ouvrir le moniteur série et on espère que ça marche :)
//Niveau 2 : Si ça marche, brancher un buzzer sur la carte et lui assigner une broche dans le programme. Enregistrer et compiler !
//Niveau 3 : Si ça marche, ajouter quelques lignes de code à la fin de la boucle loop() de sorte à ce que le buzzer bippe lorsque l'obstacle détecté est trop près. Enregistrer et tester !

const int trig = 2;   // broche de l'émetteur d'ultrasons
const int echo = 3;   // broche du récepteur

const unsigned long timeout = 25000UL;    // durée pendant laquelle le récepteur attend un écho (25000 microsecondes)

const float sound_speed = 0.340; // vitesse du son en mm par microseconde. Attention à bien définir un float pour calculs ultérieurs (bugs si définition de int)
 
long mesure = 0 ;         // durée mesurée (peut être déclarée dans la loop) 
float distance = 0 ;      // distance calculée (peut être déclarée dans la loop)

void setup() {
  Serial.begin(9600);
  pinMode(trig, OUTPUT);
  digitalWrite(trig, LOW);
  pinMode(echo, INPUT);

}

void loop() {
  
  // Lance une mesure de distance en envoyant une impulsion HIGH de 10µs sur la broche TRIGGER */
  digitalWrite(trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig, LOW);
  
 // Mesure le temps entre l'envoi de l'impulsion ultrasonique et son écho (si il existe)

  mesure = pulseIn(echo, HIGH, timeout);

/* pulseIn => Lit la durée d'une impulsion (soit niveau HAUT, soit niveau BAS) appliquée sur une broche 
 (configurée en ENTREE). Par exemple, si le paramètre valeur est HAUT, l'instruction pulseIn() 
 attend que la broche passe à HAUT, commence alors le chronométrage, attend que la broche repasse 
 au niveau BAS et stoppe alors le chronométrage. L'instruction renvoie la durée de l'impulsion en microsecondes 
L'instruction s'arrête et renvoie 0 si aucune impulsion n'est survenue dans un temps spécifié.*/

  // Calcule la distance à l'obstacle
  distance = mesure / 2 * sound_speed;

  // donne le résultat de la mesure
  Serial.print("Attention, l'obstacle se trouve à ");
  Serial.print(distance);
  Serial.println(" mm !!!");

  // Ajouter ici des lignes de code programmant la sonnerie d'une alarme si l'obstacle se trouve en-deçà d'une certaine distance
  //
  //
  //
  
  delay(300);
}
